//
// LocalLibrary.cpp
// Library C++ code
// ----------------------------------
// Developed with embedXcode
// http://embedXcode.weebly.com
//
// Project VAW_main
//
// Created by Rei VILO, mars 18, 2013 14:44
// embedXcode.weebly.com
//
//
// Copyright © Rei VILO, 2013
// Licence CC = BY NC SA
//
// See LocalLibrary.cpp.h and ReadMe.txt for references
//

///
/// @name	Delays in microseconds
/// @note   mesaured on a MSP430G2553
///
/// @{

#define DELAY_START_BIT 90 ///< start bit
#define DELAY_SEND_BIT 88 ///< data bits
#define DELAY_STOP_BIT 88 ///< stop bit

/// @}

#include "SerialTX.h"

SerialTX::SerialTX(uint8_t pin)
{
    _pin = pin;
}

void SerialTX::begin()
{
    pinMode(_pin, OUTPUT);
    digitalWrite(_pin, HIGH);
}

// virtual from print
size_t SerialTX::write(uint8_t ui8)
{
    // start
    digitalWrite(_pin, LOW);
    delayMicroseconds(DELAY_START_BIT);
    
    // send
    for (uint8_t i=0; i<8; i++) {
        digitalWrite(_pin, (ui8 & 0x01));
        delayMicroseconds(DELAY_SEND_BIT);
        ui8 >>= 1;
    }
    
    
    // stop
    digitalWrite(_pin, HIGH);
    delayMicroseconds(DELAY_STOP_BIT);
    return 1;
}


